# THIESE COMMANDS ARE EXECUTED BY: tag x


execute as @s[scores={countdown=..501}] unless entity @s[tag=startGame] run function main:_ig_cd

execute as @s[tag=startGame] run scoreboard players add @s start 1
execute as @s[tag=startGame,scores={start=1}] run tellraw @a ["",{"text":"Starting level..","color":"green","bold":true}]
execute as @s[tag=startGame,scores={start=1}] run function main:mapfill2

execute as @s[tag=startGame,scores={start=100}] run title @a title ["",{"text":"5","color":"red","bold":true}]
execute as @s[tag=startGame,scores={start=120}] run title @a title ["",{"text":"4","color":"gold","bold":true}]
execute as @s[tag=startGame,scores={start=140}] run title @a title ["",{"text":"3","color":"yellow","bold":true}]
execute as @s[tag=startGame,scores={start=160}] run title @a title ["",{"text":"2","color":"green","bold":true}]
execute as @s[tag=startGame,scores={start=180}] run title @a title ["",{"text":"1","color":"green","bold":true}]
execute as @s[tag=startGame,scores={start=180}] run scoreboard players set @a M 0
execute as @s[tag=startGame,scores={start=100}] run playsound minecraft:block.note_block.xylophone master @a ~ ~ ~ 1 2 1
execute as @s[tag=startGame,scores={start=120}] run playsound minecraft:block.note_block.xylophone master @a ~ ~ ~ 1 2 1
execute as @s[tag=startGame,scores={start=140}] run playsound minecraft:block.note_block.xylophone master @a ~ ~ ~ 1 2 1
execute as @s[tag=startGame,scores={start=160}] run playsound minecraft:block.note_block.xylophone master @a ~ ~ ~ 1 2 1
execute as @s[tag=startGame,scores={start=180}] run playsound minecraft:block.note_block.xylophone master @a ~ ~ ~ 1 2 1
execute as @s[tag=startGame,scores={start=200}] run function main:glassbreak
execute as @s[tag=startGame,scores={start=200}] run playsound minecraft:entity.phantom.ambient master @a ~ ~ ~ 1 0.7 1
execute as @s[tag=startGame,scores={start=200}] run playsound minecraft:entity.phantom.ambient master @a ~ ~ ~ 1 0.4 1
execute as @s[tag=startGame,scores={start=200}] run playsound minecraft:entity.phantom.ambient master @a ~ ~ ~ 1 1 1


# FAST LADDER
execute as @a[scores={ladder=1..}] at @s if block ~ ~ ~ minecraft:ladder run tp @s ~ ~.2 ~
execute as @a[scores={ladder=1..}] run scoreboard players reset @s ladder

#SPEED WHEN FALL
execute as @a[gamemode=!spectator] at @s unless block ~ ~-3 ~ minecraft:slime_block unless block ~ ~-2 ~ minecraft:slime_block unless block ~ ~-1 ~ minecraft:slime_block if entity @s[y=44,dy=1.5] run effect give @s minecraft:speed 1 2 true

execute as @a[gamemode=!spectator] at @s if entity @s[y=47.5,dy=1] run effect clear @s minecraft:speed

execute as @a[gamemode=!spectator] at @s unless block ~ ~-1 ~ minecraft:slime_block if block ~ ~-1 ~ minecraft:lapis_block run effect give @s minecraft:dolphins_grace 1 0 true
execute as @a[gamemode=!spectator] at @s unless block ~ ~-1 ~ minecraft:slime_block if block ~ ~-1 ~ minecraft:lapis_block run effect give @s minecraft:speed 1 2 true
execute as @a[gamemode=!spectator] at @s unless block ~ ~-1 ~ minecraft:slime_block if block ~ ~-2 ~ minecraft:lapis_block run effect give @s minecraft:speed 1 2 true
execute as @a[gamemode=!spectator] at @s unless block ~ ~-2 ~ minecraft:slime_block if block ~ ~-3 ~ minecraft:lapis_block run effect give @s minecraft:speed 1 2 true
execute as @a[gamemode=!spectator] at @s if block ~ ~-3 ~ minecraft:lapis_block run effect clear @s minecraft:speed



#TEST IF SOMEONE JOINS IG
execute as @a[scores={joinIG=1..}] run tag @s add IGjoin
gamemode spectator @a[scores={joinIG=1..}]
execute as @a[scores={joinIG=1..}] run tp @s @r[tag=!IGjoin,limit=1]
scoreboard players reset @a joinIG

gamemode spectator @a[tag=!spawn]
execute as @a[tag=!spawn] run tp @s @r[tag=!IGjoin,limit=1]
execute as @a[tag=!spawn] run tag @s add IGjoin
execute as @a[tag=!spawn] run tellraw @s ["",{"text":"Welcome ","color":"yellow","bold":true},{"selector":"@s","color":"yellow","bold":true},{"text":"!\n\n","color":"yellow","bold":true},{"text":"Phantom Run is a parkour map where you escape from a giant phantom.\n","color":"green","bold":false},{"text":"There are 6 different levels to play.\n","color":"aqua"},{"text":"Phantom speed difficulty can be changed on the right side.\nOther settings are on the left side.\n","color":"red"}]
tag @a add spawn

#INVIS

execute if entity @s[tag=inv] run effect give @a[gamemode=!spectator] minecraft:invisibility 1 0 true




# TEST WHEN PLAYERS ON GOAL
execute as @e[tag=goalparticle] at @s run particle minecraft:witch ~ ~ ~ 0.5 0 0.5 0.2 2
execute as @a[gamemode=!spectator] at @s if block ~ ~-2 ~ minecraft:emerald_block run tag @s add win
execute as @a[tag=win] run tag @s add win2
execute as @a[tag=win] run tag @s add goal
execute as @a[tag=win] run gamemode spectator @s
execute as @a[tag=win] at @s run playsound minecraft:entity.player.levelup master @a ~ ~ ~ 100 1.4 0
execute as @a[tag=win] run title @s times 0 90 5
execute as @a[tag=win] run title @s subtitle ["",{"text":"You are now spectating.","color":"red","bold":true}]
execute as @a[tag=win] run title @s title ["",{"text":"YOU WON!","color":"yellow","bold":true}]
execute as @a[tag=win,limit=1] run tellraw @a ["",{"selector":"@a[limit=1,tag=win]","bold":true},{"text":" reached the goal.","color":"aqua","bold":false}]
execute as @a[tag=win] run tag @s remove win

# TIMER AND LEADERBOARD

execute if entity @e[tag=x,scores={start=200..}] run scoreboard players add @a[gamemode=!spectator] MS2 1


scoreboard players add @a[scores={MS2=2..}] MS 1
scoreboard players reset @a[scores={MS2=2..}] MS2
scoreboard players add @a[scores={MS=10..}] S 1
scoreboard players set @a[scores={MS=10..}] MS 0
scoreboard players add @a[scores={S=59..}] M 1
scoreboard players set @a[scores={S=59..}] S 0

execute as @a[gamemode=!spectator,scores={S=10..}] run title @s actionbar ["",{"score":{"name":"@s","objective":"M"},"color":"yellow","bold":true},{"text":":","color":"gold","bold":false},{"score":{"name":"@s","objective":"S"},"color":"yellow","bold":true},{"text":":","color":"gold","bold":false},{"score":{"name":"@s","objective":"MS"},"color":"yellow","bold":true}]
execute as @a[gamemode=!spectator,scores={S=..9}] run title @s actionbar ["",{"score":{"name":"@s","objective":"M"},"color":"yellow","bold":true},{"text":":","color":"gold","bold":false},{"text":"0","color":"yellow","bold":true},{"score":{"name":"@s","objective":"S"},"color":"yellow","bold":true},{"text":":","color":"gold","bold":false},{"score":{"name":"@s","objective":"MS"},"color":"yellow","bold":true}]

#FIND LAST PLAYER ALIVE
execute as @a[gamemode=!spectator] run scoreboard players add @e[tag=x,scores={start=100}] players 1
execute as @s[tag=x,scores={players=1}] run tag @a[gamemode=!spectator,limit=1] add last1
execute as @s[tag=x,scores={players=1}] run scoreboard players reset @s players

#FIND 1ST PERSON TO REACH GOAL
execute as @a[tag=win2,limit=1] unless entity @a[tag=last2] run tag @s add last2





#PHANTOM SPAWN
execute as @s[tag=startGame,scores={speed=1..2,start=600,level=1}] run summon phantom -10.0 50 8.0 {NoGravity:1b,Silent:1b,Invulnerable:1b,NoAI:1b,Size:50,Team:"default",Rotation:[-90F,10F],Tags:["phantom1"]}
execute as @s[tag=startGame,scores={speed=1..2,start=600,level=2}] run summon phantom -10.0 50 -44.0 {NoGravity:1b,Silent:1b,Invulnerable:1b,NoAI:1b,Size:50,Team:"default",Rotation:[-90F,10F],Tags:["phantom1"]}
execute as @s[tag=startGame,scores={speed=1..2,start=600,level=3}] run summon phantom -10.0 50 -100.0 {NoGravity:1b,Silent:1b,Invulnerable:1b,NoAI:1b,Size:50,Team:"default",Rotation:[-90F,10F],Tags:["phantom1"]}
execute as @s[tag=startGame,scores={speed=1..2,start=600,level=4}] run summon phantom -10.0 50 -170.0 {NoGravity:1b,Silent:1b,Invulnerable:1b,NoAI:1b,Size:50,Team:"default",Rotation:[-90F,10F],Tags:["phantom1"]}
execute as @s[tag=startGame,scores={speed=1..2,start=600,level=5}] run summon phantom -15.0 55 -241.0 {NoGravity:1b,Silent:1b,Invulnerable:1b,NoAI:1b,Size:50,Team:"default",Rotation:[-90F,10F],Tags:["phantom1"]}
execute as @s[tag=startGame,scores={speed=1..2,start=600,level=6}] run summon phantom -10.0 50 -311.0 {NoGravity:1b,Silent:1b,Invulnerable:1b,NoAI:1b,Size:50,Team:"default",Rotation:[-90F,10F],Tags:["phantom1"]}
execute as @s[tag=startGame,scores={speed=1..2,start=600}] run playsound minecraft:entity.phantom.ambient master @a ~ ~ ~ 1 0.4 1
execute as @s[tag=startGame,scores={speed=1..2,start=600}] run playsound minecraft:entity.phantom.ambient master @a ~ ~ ~ 1 0.4 1
execute as @s[tag=startGame,scores={speed=1..2,start=600}] run playsound minecraft:entity.phantom.ambient master @a ~ ~ ~ 1 0.4 1
execute as @s[tag=startGame,scores={speed=1..2,start=600}] run playsound minecraft:entity.phantom.ambient master @a ~ ~ ~ 1 0.4 1
execute as @s[tag=startGame,scores={speed=1..2,start=600}] run playsound minecraft:entity.wither.spawn master @a ~ ~ ~ 1 1.2 1

execute as @s[tag=startGame,scores={speed=3,start=450,level=1}] run summon phantom -10.0 50 8.0 {NoGravity:1b,Silent:1b,Invulnerable:1b,NoAI:1b,Size:50,Team:"default",Rotation:[-90F,10F],Tags:["phantom1"]}
execute as @s[tag=startGame,scores={speed=3,start=450,level=2}] run summon phantom -10.0 50 -44.0 {NoGravity:1b,Silent:1b,Invulnerable:1b,NoAI:1b,Size:50,Team:"default",Rotation:[-90F,10F],Tags:["phantom1"]}
execute as @s[tag=startGame,scores={speed=3,start=450,level=3}] run summon phantom -10.0 50 -100.0 {NoGravity:1b,Silent:1b,Invulnerable:1b,NoAI:1b,Size:50,Team:"default",Rotation:[-90F,10F],Tags:["phantom1"]}
execute as @s[tag=startGame,scores={speed=3,start=450,level=4}] run summon phantom -10.0 50 -170.0 {NoGravity:1b,Silent:1b,Invulnerable:1b,NoAI:1b,Size:50,Team:"default",Rotation:[-90F,10F],Tags:["phantom1"]}
execute as @s[tag=startGame,scores={speed=3,start=450,level=5}] run summon phantom -20.0 55 -241.0 {NoGravity:1b,Silent:1b,Invulnerable:1b,NoAI:1b,Size:50,Team:"default",Rotation:[-90F,10F],Tags:["phantom1"]}
execute as @s[tag=startGame,scores={speed=3,start=450,level=6}] run summon phantom -10.0 50 -311.0 {NoGravity:1b,Silent:1b,Invulnerable:1b,NoAI:1b,Size:50,Team:"default",Rotation:[-90F,10F],Tags:["phantom1"]}
execute as @s[tag=startGame,scores={speed=3,start=450}] run playsound minecraft:entity.phantom.ambient master @a ~ ~ ~ 1 0.4 1
execute as @s[tag=startGame,scores={speed=3,start=450}] run playsound minecraft:entity.phantom.ambient master @a ~ ~ ~ 1 0.4 1
execute as @s[tag=startGame,scores={speed=3,start=450}] run playsound minecraft:entity.phantom.ambient master @a ~ ~ ~ 1 0.4 1
execute as @s[tag=startGame,scores={speed=3,start=450}] run playsound minecraft:entity.phantom.ambient master @a ~ ~ ~ 1 0.4 1
execute as @s[tag=startGame,scores={speed=3,start=450}] run playsound minecraft:entity.wither.spawn master @a ~ ~ ~ 1 1.2 1

execute as @s[tag=startGame,scores={speed=4,start=250,level=1}] run summon phantom -10.0 50 8.0 {NoGravity:1b,Silent:1b,Invulnerable:1b,NoAI:1b,Size:50,Team:"default",Rotation:[-90F,10F],Tags:["phantom1"]}
execute as @s[tag=startGame,scores={speed=4,start=250,level=2}] run summon phantom -10.0 50 -44.0 {NoGravity:1b,Silent:1b,Invulnerable:1b,NoAI:1b,Size:50,Team:"default",Rotation:[-90F,10F],Tags:["phantom1"]}
execute as @s[tag=startGame,scores={speed=4,start=250,level=3}] run summon phantom -10.0 50 -100.0 {NoGravity:1b,Silent:1b,Invulnerable:1b,NoAI:1b,Size:50,Team:"default",Rotation:[-90F,10F],Tags:["phantom1"]}
execute as @s[tag=startGame,scores={speed=4,start=250,level=4}] run summon phantom -10.0 50 -170.0 {NoGravity:1b,Silent:1b,Invulnerable:1b,NoAI:1b,Size:50,Team:"default",Rotation:[-90F,10F],Tags:["phantom1"]}
execute as @s[tag=startGame,scores={speed=4,start=250,level=5}] run summon phantom -25.0 55 -241.0 {NoGravity:1b,Silent:1b,Invulnerable:1b,NoAI:1b,Size:50,Team:"default",Rotation:[-90F,10F],Tags:["phantom1"]}
execute as @s[tag=startGame,scores={speed=4,start=250,level=6}] run summon phantom -10.0 50 -311.0 {NoGravity:1b,Silent:1b,Invulnerable:1b,NoAI:1b,Size:50,Team:"default",Rotation:[-90F,10F],Tags:["phantom1"]}
execute as @s[tag=startGame,scores={speed=4,start=250}] run playsound minecraft:entity.phantom.ambient master @a ~ ~ ~ 1 0.4 1
execute as @s[tag=startGame,scores={speed=4,start=250}] run playsound minecraft:entity.phantom.ambient master @a ~ ~ ~ 1 0.4 1
execute as @s[tag=startGame,scores={speed=4,start=250}] run playsound minecraft:entity.phantom.ambient master @a ~ ~ ~ 1 0.4 1
execute as @s[tag=startGame,scores={speed=4,start=250}] run playsound minecraft:entity.phantom.ambient master @a ~ ~ ~ 1 0.4 1
execute as @s[tag=startGame,scores={speed=4,start=250}] run playsound minecraft:entity.wither.spawn master @a ~ ~ ~ 1 1.2 1

#PHANTOM EAT PLAYER
execute as @e[tag=phantom1,limit=1] at @s positioned ~-1 ~-12 ~-16 run tag @a[dx=3,dy=30,dz=32,gamemode=!spectator] add death
execute as @a[tag=death] run tag @s add death2
execute as @a[tag=death] run tag @s add goal
execute as @a[tag=death] run gamemode spectator @s
execute as @a[tag=death] at @s run playsound minecraft:entity.player.death master @a ~ ~ ~ 100 1.3 0
execute as @a[tag=death] at @s run playsound minecraft:entity.player.death master @a ~ ~ ~ 100 1 0
execute as @a[tag=death] at @s run playsound minecraft:entity.player.death master @a ~ ~ ~ 100 0.7 0
execute as @a[tag=death] at @s run playsound minecraft:entity.player.death master @a ~ ~ ~ 100 0.3 0
execute as @a[tag=death] at @s run playsound minecraft:entity.evoker_fangs.attack master @a ~ ~ ~ 100 0.7 0
execute as @a[tag=death] at @s run playsound minecraft:entity.player.burp master @a ~ ~ ~ 100 0.8 0
execute as @a[tag=death] run title @s times 0 90 5
execute as @a[tag=death] run title @s subtitle ["",{"text":"You are now spectating.","color":"red","bold":true}]
execute as @a[tag=death] run title @s title ["",{"text":"YOU DIED!","color":"dark_red","bold":true}]
execute as @a[tag=death,limit=1] run tellraw @a ["",{"selector":"@a[limit=1,tag=death]","bold":true},{"text":" got eaten by the phantom.","color":"aqua","bold":false}]
execute as @a[tag=death] run scoreboard players remove @e[tag=x] players 1
execute as @a[tag=death] run tag @s remove death

#TP PHANTOM + DIFFICULTY SPEEDS
execute as @s[tag=startGame,scores={speed=1,start=600..}] unless entity @s[scores={endtimer=1..}] run execute as @e[tag=phantom1,limit=1] at @s run tp @s ~0.02 ~ ~
execute as @s[tag=startGame,scores={speed=2,start=600..}] unless entity @s[scores={endtimer=1..}] run execute as @e[tag=phantom1,limit=1] at @s run tp @s ~0.035 ~ ~
execute as @s[tag=startGame,scores={speed=3,start=450..}] unless entity @s[scores={endtimer=1..}] run execute as @e[tag=phantom1,limit=1] at @s run tp @s ~0.05 ~ ~
execute as @s[tag=startGame,scores={speed=4,start=250..}] unless entity @s[scores={endtimer=1..}] run execute as @e[tag=phantom1,limit=1] at @s run tp @s ~0.07 ~ ~
execute as @e[tag=phantom1] run scoreboard players add @s tntclock 1
execute as @e[tag=phantom1,scores={tntclock=41..}] run scoreboard players reset @s tntclock

#PHANTOM EFFECTS "sub-function"
execute as @s[tag=pbb,tag=startGame,scores={start=250..}] unless entity @s[scores={endtimer=1..}] run execute as @e[tag=phantom1,limit=1,scores={tntclock=20}] run function main:phantomeffects
execute as @s[tag=pbb,tag=startGame,scores={start=250..}] unless entity @s[scores={endtimer=1..}] run execute as @e[tag=phantom1,limit=1,scores={tntclock=40}] run function main:phantomeffects

#PHANTOM SPEED IF PLAYER FAR AWAY FROM PHANTOM
execute as @s[tag=fp,scores={speed=1}] as @e[tag=phantom1,limit=1] at @s unless entity @a[gamemode=!spectator,distance=..40] unless entity @s[scores={endtimer=1..}] run tp @s ~0.01 ~ ~
execute as @s[tag=fp,scores={speed=2}] as @e[tag=phantom1,limit=1] at @s unless entity @a[gamemode=!spectator,distance=..35] unless entity @s[scores={endtimer=1..}] run tp @s ~0.03 ~ ~
execute as @s[tag=fp,scores={speed=3}] as @e[tag=phantom1,limit=1] at @s unless entity @a[gamemode=!spectator,distance=..32] unless entity @s[scores={endtimer=1..}] run tp @s ~0.06 ~ ~
execute as @s[tag=fp,scores={speed=4}] as @e[tag=phantom1,limit=1] at @s unless entity @a[gamemode=!spectator,distance=..25] unless entity @s[scores={endtimer=1..}] run tp @s ~0.09 ~ ~


# TEST GAME END
execute as @s unless entity @a[tag=!IGjoin,tag=!goal] run function main:end

# ERROR END >> If phantom somehow goes trough entire level and wont find any win method
execute as @e[tag=errorwin] at @s positioned ~3 ~ ~ if entity @e[tag=phantom1,dx=1,dy=20,dz=32] run function main:stop



